<template>
    <div id="app">
        <ContactAddEdit
            v-if="screen == 'addEdit'"
            @change-action-edit="activateEdit"
            @emit-back="goBack"
            @emit-ok="acceptAdditionEdition"
            :selectedContact="selectedContact"
            :msg="msg"
        />

        <ContactList
            v-if="screen == 'list'"
            :contacts="agendaData"
            @click-to-info="goToContactDetails"
            @activate-add-screen="activateAdd"
            :msg="msg"
        />

        <ContactDetails
            v-if="screen == 'contactDetails'"
            :selectedContact="selectedContact"
            @button-back="goToList"
            @button-edit="activateEdit"
            @send-to-delete="deleteContactChangeScreens"
            :msg="msg"
        />
    </div>
</template>

<script>
import { v4 as uuidv4 } from 'uuid'
import ContactAddEdit from '@/components/ContactAddEdit.vue'
import ContactList from '@/components/ContactList.vue'
import ContactDetails from '@/components/ContactDetails.vue'

export default {
    name: 'App',
    components: {
        ContactAddEdit,
        ContactList,
        ContactDetails,
    },
    data() {
        return {
            action: null,
            screen: 'list',
            msg: '',
            url: '/api/contacts',
            agendaData: [],
            selectedContact: null,
            completeURL: null,
        }
    },

    mounted: function() {
        this.callAgenda()
    },

    methods: {
        async callAgenda() {
            this.agendaData = await this.loadAgenda()
        },
        async loadAgenda() {
            const response = await fetch(this.url)
            return await response.json()
        },
        changeAction(state) {
            this.action = state
        },
        goToList() {
            this.screen = 'list'
        },
        goBack() {
            if (this.action === 'add') {
                this.screen = 'list'
            } else if (this.action === 'edit') {
                this.screen = 'contactDetails'
            }
        },
        goToContactDetails(contact) {
            this.screen = 'contactDetails'
            this.selectedContact = contact
        },
        activateEdit(contact) {
            this.changeAction('edit')
            this.changeMessage()
            this.selectedContact = contact
            this.screen = 'addEdit'
        },
        activateAdd() {
            ;(this.screen = 'addEdit'), this.changeAction('add')
            this.changeMessage()
            if (this.action === 'add') {
                this.selectedContact = {
                    id: null,
                    name: null,
                    surname: null,
                    telephone: null,
                    email: null,
                }
            }
        },
        changeMessage() {
            if (this.action === 'edit') {
                this.msg = 'Edit'
            } else if (this.action === 'add') {
                this.msg = 'Add'
            }
        },

        async addToList() {
            await fetch(this.url, {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                    id: uuidv4(),
                    name: this.selectedContact.name,
                    surname: this.selectedContact.surname,
                    telephone: this.selectedContact.telephone,
                    email: this.selectedContact.email,
                }),
            }).then(response => response.json())
        },

        async editContact() {
            await fetch(this.url + '/' + this.selectedContact.id, {
                method: 'PUT',
                headers: {
                    'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                    id: this.selectedContact.id,
                    name: this.selectedContact.name,
                    surname: this.selectedContact.surname,
                    telephone: this.selectedContact.telephone,
                    email: this.selectedContact.email,
                }),
            }).then(response => response.json())
        },

        async deleteContact() {
            this.completeURL = this.url + '/' + this.selectedContact.id
            await this.deleteFromList()
        },
        async deleteFromList() {
            await fetch(this.completeURL, {
                method: 'DELETE',
            }).then(response => response.json())
        },
        async acceptAdditionEdition(contact) {
            this.selectedContact = contact
            if (this.action === 'add') {
                await this.addToList()
                this.screen = 'list'
                this.callAgenda()
            } else if (this.action === 'edit') {
                await this.editContact()
                this.screen = 'contactDetails'
                this.callAgenda()
            }
        },
        async deleteContactChangeScreens(selectedContact) {
            this.selectedContact = selectedContact
            this.goToList()
            await this.deleteContact()
            this.callAgenda()
        },
    },
}
</script>

<style>
@import url('https://fonts.googleapis.com/css?family=Roboto&display=swap');
#app {
    margin: 0;
    padding: 0;
    font-family: 'Roboto';
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    color: #2c3e50;
    margin-top: 2rem;
    display: flex;
    justify-content: center;
    /*     background-image: url('../assets/fonditodesierto.jpeg') no-repeat;
    background-size: cover; */
}
h1 {
    font-size: 1.8rem;
}
</style>
